<template>
<div class="w-100">
    <v-sheet v-if="!initialized && loading" color="grey lighten-4 " class="px-3 pt-3 pb-12">
          <v-responsive
      max-width="100%"
      class="mx-auto"
    >
      <v-skeleton-loader
        ref="skeleton"
        type="table"
        class="mx-auto"
      ></v-skeleton-loader>
       </v-responsive>
  </v-sheet>
  <v-data-table v-else
    :headers="headers"
    v-model="selected"
    show-select
    item-key="name"
    :items="items"
    :search="search"
    :single-select="singleSelect"
    sort-by=""
    class="elevation-1 w-100"
  >
    <template v-slot:top>
      <v-toolbar flat color="white">
        <v-dialog v-model="dialog" max-width="900px" @click:outside="close">
              <template v-slot:activator="{ on, attrs }">
                <v-card-title  class="w-100">
                    Patients
                      <v-btn small
                            color="secondary"
                            dark
                            class="mb-2 ml-2"
                            v-bind="attrs"
                            v-on="on"
                            >Nouveau
                      </v-btn>
                      <v-spacer></v-spacer>
                            <v-text-field
                                v-model="search"
                                class="mb-2"
                                append-icon="mdi-magnify"
                                label="Recherche"
                                single-line
                                hide-details
                        ></v-text-field>
                </v-card-title>
              </template>

                    <v-spacer></v-spacer>
              <v-card>
              <ValidationObserver class="w-100" ref="form" v-slot="{ invalid  }">

                <v-card-title>
                  <span class="headline">{{ formTitle }}</span>
                            <v-spacer></v-spacer>
          <v-menu bottom left>
            <template v-slot:activator="{ on, attrs }">
                            <v-btn :disabled="disableAddInsuranceButton" small  @click="addInsurance"  color="secondary" dark>
                              Ajouter une assurance
                            </v-btn>
            </template>
          </v-menu>
                </v-card-title>

                <v-card-text>
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6" md="6">
                          <ValidationProvider :custom-messages="errorMessages.lastname" v-slot="{ errors }" name="lastname" rules="required|max:10|min:2">
                            <v-text-field
                              v-model="editedItem.lastname" label="Nom du patient"
                              :counter="10"
                              :error-messages="errors"
                              outlined
                            ></v-text-field>
                          </ValidationProvider>
                      </v-col>
                      <v-col cols="12" sm="6" md="6">
                          <ValidationProvider :custom-messages="errorMessages.firstname" v-slot="{ errors }" name="firstname" rules="min:2">
                            <v-text-field
                              v-model="editedItem.firstname" label="Prenom du patient"
                              :counter="10"
                              :error-messages="errors"
                              outlined
                            ></v-text-field>
                          </ValidationProvider>
                      </v-col>
                      <v-col cols="12" :sm=" !hasInsurances ? 12 : 4 " :md="!hasInsurances ? 12 : 4 ">
                      <ValidationProvider :custom-messages="errorMessages.birthdate" v-slot="{ errors }" name="birthdate" rules="required|date|date_gtt">
                            <v-text-field
                              v-model="editedItem.birthdate" type="date" 
                              label="Date de naissance"
                              :error-messages="errors"
                              required
                              outlined
                            ></v-text-field>
                          </ValidationProvider>
                      </v-col>
                      <v-col cols="12" :sm=" !hasInsurances ? 6 : 4 " :md="!hasInsurances ? 6 : 4 ">
                        <ValidationProvider :custom-messages="errorMessages.phone_number" v-slot="{ errors }" name="phone_number" rules="required">
                            <v-text-field
                              v-model="editedItem.phone_number"
                                label="Numero de téléphone"
                              :error-messages="errors"
                              required
                              outlined
                            ></v-text-field>
                          </ValidationProvider>
                      </v-col>
                      <v-col cols="12" :sm=" !hasInsurances ? 6 : 4 " :md="!hasInsurances ? 6 : 4 ">
                          <ValidationProvider :custom-messages="errorMessages.phone_number" v-slot="{ errors }" name="phone_number" rules="required">
                            <v-select
                              outlined
                              v-model="editedItem.gender"
                              label="Genre du patient"
                              :error-messages="errors"
                              :items="genders"
                              item-text="label"
                              item-value="value"
                            >
                            </v-select>
                          </ValidationProvider>
                      </v-col>
                      <v-container>
                    <v-row class="bloc-insurance" v-for="(insurance,key) in editedItem.insurances" :key="key">
                        <div class="col-md-12 row">
                                    <v-col cols="12" sm="3" md="3">
                                        <ValidationProvider :custom-messages="errorMessages.insurance_id" v-slot="{ errors }" :name="'insurances['+key+'].insurance_id'" rules="required">
                                        <v-select
                                          v-model="editedItem.insurances[key].insurance_id"
                                          :items="insurances"
                                          menu-props="auto"
                                          label="Assurance"
                                           :error-messages="errors"
                                          item-value="id"
                                          item-text="name"
                                          hide-details
                                          outlined
                                        ></v-select>
                                      </ValidationProvider>

                                    </v-col>
                                    <v-col cols="12" sm="4" md="4">
                                      <ValidationProvider :custom-messages="errorMessages.insurance_number" v-slot="{ errors }" :name="'insurances['+key+'].insurance_number'" rules="required">
                                       <v-text-field outlined v-model="editedItem.insurances[key].insurance_number" :error-messages="errors" label="Le n° de l'assurance"></v-text-field>
                                      </ValidationProvider>
                                    </v-col>
                                    <v-col cols="12" sm="5" md="5">
                                          <p class="mb-0">Statut de l'assuré</p>
                                          <v-radio-group class="mt-0" v-model="editedItem.insurances[key].main_insured" row>
                                            <v-radio label="Assuré principal" :value="true"></v-radio>
                                            <v-radio label="Ayant droit" :value="false"></v-radio>
                                          </v-radio-group>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="6" v-if="!editedItem.insurances[key].main_insured">
                                        <ValidationProvider :custom-messages="errorMessages.main_insured_name" v-slot="{ errors }" :name="'insurances['+key+'].main_insured_name'" rules="required">
                                         <v-text-field  outlined v-model="editedItem.insurances[key].main_insured_name"  :error-messages="errors" label="Nom & Prénom de l'assuré principal"></v-text-field>
                                        </ValidationProvider>
                                    </v-col>
                                    <v-col cols="12" sm="6" md="6" v-if="!editedItem.insurances[key].main_insured">
                                        <ValidationProvider :custom-messages="errorMessages.main_insured_number" v-slot="{ errors }" :name="'insurances['+key+'].main_insured_number'" rules="required">
                                              <v-text-field   :error-messages="errors"  outlined v-model="editedItem.insurances[key].main_insured_number" type="text" label="N° Assuré principal"></v-text-field>
                                        </ValidationProvider>
                                    </v-col>
                        </div>
                                          <v-btn @click="removeInsurance(key)" class=" bloc-insurance-close mx-2" fab dark small color="red">
                                              <v-icon dark>mdi-close</v-icon>
                                              </v-btn>
          
 
                    </v-row>
                    </v-container>
                    </v-row>

                  </v-container>
                </v-card-text>

                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn depressed small color="error"  @click="close">Annuler</v-btn>
                  <v-btn  depressed  color="primary"  @click="save" :disabled="invalid">{{ edit ? 'Modifier' : 'Enregister'}}</v-btn>
                </v-card-actions>
                              </ValidationObserver>

              </v-card>
        </v-dialog>
        <v-spacer></v-spacer>

      </v-toolbar>
    </template>

    <template v-slot:item.actions="{ item }">

      <v-icon
        small
        class="mr-2"
        @click="showPatient(item)"
        >mdi-eye
      </v-icon>
        <v-icon
            small
            class="mr-2"
            @click="editItem(item)"
        >
        mdi-pencil
      </v-icon>
      <v-icon
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
         No Data
    </template>
    <template v-slot:left>
      <v-switch v-model="singleSelect" label="Single select" class="pa-3"></v-switch>
    </template>
  </v-data-table>
</div>
</template>
<script>
import { mapGetters } from 'vuex'
import * as rules from 'vee-validate/dist/rules'
import { extend, ValidationProvider, ValidationObserver } from "vee-validate";

Object.keys(rules).forEach(rule => {
  extend(rule, rules[rule]);
});

  extend('required', {
    ...rules['required'],
    message: '{_field_} can not be empty',
  })
  extend('date_gtt', value => 
  {
    //on recupere la date
    var current = moment()

    var d = moment(value)

    var diff = current.diff(d)
    //on verifie que la date n'est pas anterieure à la date courante
    return diff > 0

});
  extend('date', value => 
  {
    var dateReg = /^\d{4}([-])\d{2}([-])\d{2}$/
    //on recupere la date

    //on verifie que la date n'est pas anterieure à la date courante
    return  value.match(dateReg)

});
  export default {
        components: {
      ValidationProvider,
      ValidationObserver,
    },
    data: () => ({
                errorMessages:
                  {
                    lastname : 
                    {
                      required: 'Le nom est requis',
                      max:'Le nom  doit avoir moins de 10 caractères',
                      min:'Le nom doit avoir au moins de 2 caractères'
                    },
                    firstname:
                    {
                      min:'Le prénom  doit avoir au moins de 2 caractères'
                    },
                    phone_number:
                    {
                      required:'Le n° de téléphone est requis'
                    },
                    gender:
                    {
                      required:'Le genre du patient est requis'
                    },
                    birthdate:
                    {
                      date:'La date doit etre avoir un format valide',
                      date_gtt:'La date ne doit être ulterieure à la date en cours',
                      required:'La date de naissance est requise'
                    },
                    insurance_id:
                    {
                      required:'L\'assurance est requise'
                    },
                    insurance_number:
                    {
                      required:"Le n° de l'assurance est requis",
                    },
                    main_insured_number:
                    {
                      required:"Le n° de l'assurance est requis",
                    },
                    main_insured_name:
                    {
                      required:"Le nom de l'assuré est requis",
                    },
                  }
                ,
                search: '',
                dialog: false,
                // insurances:[],
                singleSelect: false,
                edit:false,
                selected: [],
                headers: [
                        {
                        text: 'Nom(s)/Prénom(s)',
                        align: 'start',
                        sortable: true,
                        value: 'fullName',
                        },
                        { text: 'Date de naissance', value: 'birthdate' },
                        { text: 'N° Téléphone', value: 'phone_number' },
                        { text: "Dernière date", value: 'created_at' },
                        { text: "Sexe", value: 'gender' },
                        { text: 'Actions', value: 'actions', sortable: false },
                    ],

                  editedItem: {
                    lastname: '',
                    firstname: "",
                    phone_number: "",
                    birthdate: "",
                    gender: "",
                    insurances : []
                    },

                    defaultItem: {
                        lastname: '',
                        firstname: "",
                        phone_number:"",
                        birthdate: "",
                        gender: "",
                        insurances : []
                        },

    }),

    computed: {
        ...mapGetters({initialized:'patients/initialized', genders:'params/_genders',moreExists:'patients/moreExists',next_page_url:"patients/next_page_url",total:"patients/total"
                           ,paginator:"patients/paginator",current_page:"patients/current_page",items:"patients/_items",loading:"patients/loading",insurances:"params/_insurances",loaded:"patients/loaded"}),

      formTitle () {
        return !this.edit? 'Nouveau patient' : 'Modification Patient'
      },
      disableAddInsuranceButton()
      {
        if(this.editedItem.insurances)
        return this.editedItem.insurances.length >= 3 ;
        else
        return false
      },
      hasInsurances()
      { 
        if(this.editedItem.insurances)
        return this.editedItem.insurances.length > 0
        else
        return false
      }
    },

    watch: {
      dialog (val) {
        val || this.close()
      },
      edit (val) {
        if(val)
        {
          var insurances = []
          if(this.editedItem.insurances.length>0)
          {
              this.editedItem.insurances.forEach(
                     element => {
                      insurances.push({
                        insurance_id:element.pivot.insurance_id,
                        insurance_number:element.pivot.insurance_nr,
                        main_insured:element.pivot.main_insured == 0 ? false : true,
                        main_insured_name:element.pivot.main_insured_name,
                        main_insured_number:element.pivot.main_insured_nr
                      }) 
               });

              this.editedItem.insurances = insurances


        
          }
        }
      },
    },

    created () {
        //   this.modeEdit = false
          this.$store.dispatch('patients/init')
          this.$store.dispatch('patients/getPatients')
          //this.fetch()
    },

    methods: {
         prependIconCallback () {},
      initialize () {},

      editItem (item) {
        this.edit = true
        this.editedItem = Object.assign({}, item)
        this.dialog = true
      },
      deleteItem (item) {
          const index = this.items.indexOf(item)
          confirm('Are you sure you want to delete this item?') && this.$store.dispatch('patients/removePatient',item)
          .then(reponse =>console.log(response))
          .catch(error =>console.log(error));
      },

      close () {
        this.dialog = false
         this.edit = false

        this.$nextTick(() => {
          this.editedItem = Object.assign({}, this.defaultItem)

          this.$refs.form.reset()
          this.editedIndex = -1
        })
      },

      save () {
           this.$store.dispatch( this.edit ? 'patients/updatePatient' :'patients/addPatient',this.editedItem
          ).then
          (reponse => {

               
               flash(this.edit ? "Patient modifié" :'Nouveau patient ajouté')
               this.close()

          },(error) => 
                     {
                       if(this.$refs.form)
                       this.$refs.form.setErrors(error.response.data.errors)
                    });
      },

      //Ajoute une assurance temporaire
       addInsurance ()
       {
         if(!this.disableAddInsuranceButton)
         this.editedItem.insurances.push({insurance_id:"",insurance_number:"",main_insured:true,main_insured_name:'',main_insured_number:''})
       },
        //Retire une assurance de la liste
       removeInsurance (key)
       {
         this.editedItem.insurances.splice(key,1)
       },
       showPatient(item){
           var id = item.id
           this.$router.push({name:'patient_detail', params:{id} })
       },
    },
    
  }
</script>
<style lang="scss" scoped>
  .bloc-insurance{
    position: relative;
        border: 1px solid #c9c9c966;
  }
    .bloc-insurance-close {
    position: absolute;
right: -20px;
    top: -20px;

  }
</style>